# coding: utf-8

"""
    eLabFTW REST API v2 Documentation

    This document describes all available endpoints and methods for eLabFTW's API version 2. 

    The version of the OpenAPI document: 2.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from elabapi_python.models.patch_user_request_one_of import PatchUserRequestOneOf
from elabapi_python.models.patch_user_request_one_of1 import PatchUserRequestOneOf1
from elabapi_python.models.patch_user_request_one_of2 import PatchUserRequestOneOf2
from elabapi_python.models.patch_user_request_one_of3 import PatchUserRequestOneOf3
from elabapi_python.models.patch_user_request_one_of4 import PatchUserRequestOneOf4
from elabapi_python.models.users import Users
from pydantic import StrictStr, Field
from typing import Union, List, Set, Optional, Dict
from typing_extensions import Literal, Self

PATCHUSERREQUEST_ONE_OF_SCHEMAS = ["PatchUserRequestOneOf", "PatchUserRequestOneOf1", "PatchUserRequestOneOf2", "PatchUserRequestOneOf3", "PatchUserRequestOneOf4", "Users"]

class PatchUserRequest(BaseModel):
    """
    PatchUserRequest
    """
    # data type: Users
    oneof_schema_1_validator: Optional[Users] = None
    # data type: PatchUserRequestOneOf
    oneof_schema_2_validator: Optional[PatchUserRequestOneOf] = None
    # data type: PatchUserRequestOneOf1
    oneof_schema_3_validator: Optional[PatchUserRequestOneOf1] = None
    # data type: PatchUserRequestOneOf2
    oneof_schema_4_validator: Optional[PatchUserRequestOneOf2] = None
    # data type: PatchUserRequestOneOf3
    oneof_schema_5_validator: Optional[PatchUserRequestOneOf3] = None
    # data type: PatchUserRequestOneOf4
    oneof_schema_6_validator: Optional[PatchUserRequestOneOf4] = None
    actual_instance: Optional[Union[PatchUserRequestOneOf, PatchUserRequestOneOf1, PatchUserRequestOneOf2, PatchUserRequestOneOf3, PatchUserRequestOneOf4, Users]] = None
    one_of_schemas: Set[str] = { "PatchUserRequestOneOf", "PatchUserRequestOneOf1", "PatchUserRequestOneOf2", "PatchUserRequestOneOf3", "PatchUserRequestOneOf4", "Users" }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = PatchUserRequest.model_construct()
        error_messages = []
        match = 0
        # validate data type: Users
        if not isinstance(v, Users):
            error_messages.append(f"Error! Input type `{type(v)}` is not `Users`")
        else:
            match += 1
        # validate data type: PatchUserRequestOneOf
        if not isinstance(v, PatchUserRequestOneOf):
            error_messages.append(f"Error! Input type `{type(v)}` is not `PatchUserRequestOneOf`")
        else:
            match += 1
        # validate data type: PatchUserRequestOneOf1
        if not isinstance(v, PatchUserRequestOneOf1):
            error_messages.append(f"Error! Input type `{type(v)}` is not `PatchUserRequestOneOf1`")
        else:
            match += 1
        # validate data type: PatchUserRequestOneOf2
        if not isinstance(v, PatchUserRequestOneOf2):
            error_messages.append(f"Error! Input type `{type(v)}` is not `PatchUserRequestOneOf2`")
        else:
            match += 1
        # validate data type: PatchUserRequestOneOf3
        if not isinstance(v, PatchUserRequestOneOf3):
            error_messages.append(f"Error! Input type `{type(v)}` is not `PatchUserRequestOneOf3`")
        else:
            match += 1
        # validate data type: PatchUserRequestOneOf4
        if not isinstance(v, PatchUserRequestOneOf4):
            error_messages.append(f"Error! Input type `{type(v)}` is not `PatchUserRequestOneOf4`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in PatchUserRequest with oneOf schemas: PatchUserRequestOneOf, PatchUserRequestOneOf1, PatchUserRequestOneOf2, PatchUserRequestOneOf3, PatchUserRequestOneOf4, Users. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in PatchUserRequest with oneOf schemas: PatchUserRequestOneOf, PatchUserRequestOneOf1, PatchUserRequestOneOf2, PatchUserRequestOneOf3, PatchUserRequestOneOf4, Users. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # deserialize data into Users
        try:
            instance.actual_instance = Users.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into PatchUserRequestOneOf
        try:
            instance.actual_instance = PatchUserRequestOneOf.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into PatchUserRequestOneOf1
        try:
            instance.actual_instance = PatchUserRequestOneOf1.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into PatchUserRequestOneOf2
        try:
            instance.actual_instance = PatchUserRequestOneOf2.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into PatchUserRequestOneOf3
        try:
            instance.actual_instance = PatchUserRequestOneOf3.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into PatchUserRequestOneOf4
        try:
            instance.actual_instance = PatchUserRequestOneOf4.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into PatchUserRequest with oneOf schemas: PatchUserRequestOneOf, PatchUserRequestOneOf1, PatchUserRequestOneOf2, PatchUserRequestOneOf3, PatchUserRequestOneOf4, Users. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into PatchUserRequest with oneOf schemas: PatchUserRequestOneOf, PatchUserRequestOneOf1, PatchUserRequestOneOf2, PatchUserRequestOneOf3, PatchUserRequestOneOf4, Users. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], PatchUserRequestOneOf, PatchUserRequestOneOf1, PatchUserRequestOneOf2, PatchUserRequestOneOf3, PatchUserRequestOneOf4, Users]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


