# coding: utf-8

"""
    eLabFTW REST API v2 Documentation

    This document describes all available endpoints and methods for eLabFTW's API version 2. 

    The version of the OpenAPI document: 2.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class PostUserRequest(BaseModel):
    """
    PostUserRequest
    """ # noqa: E501
    firstname: StrictStr = Field(description="User's first name.")
    lastname: StrictStr = Field(description="User's last name.")
    email: StrictStr = Field(description="User's email address.")
    team: Optional[StrictInt] = Field(default=None, description="The team id.")
    valid_until: Optional[StrictStr] = Field(default=None, description="Date in the YYYY-MM-DD format for account expiration date.")
    orgid: Optional[StrictStr] = Field(default=None, description="Internal id.")
    usergroup: Optional[StrictInt] = Field(default=None, description="Which permissions level the user will get? `1` is Sysadmin, `2` is Admin, `4` is user (default)")
    __properties: ClassVar[List[str]] = ["firstname", "lastname", "email", "team", "valid_until", "orgid", "usergroup"]

    @field_validator('usergroup')
    def usergroup_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set([1, 2, 4]):
            raise ValueError("must be one of enum values (1, 2, 4)")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PostUserRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PostUserRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "firstname": obj.get("firstname"),
            "lastname": obj.get("lastname"),
            "email": obj.get("email"),
            "team": obj.get("team"),
            "valid_until": obj.get("valid_until"),
            "orgid": obj.get("orgid"),
            "usergroup": obj.get("usergroup")
        })
        return _obj


